#include <bits/stdc++.h>>

using namespace std;

typedef long long ll;
#define int ll

const int K=1e4+10;

int a[K];

signed main()
{
    int n,k;
    cin>>n>>k;
    for(int i=0;i<k;i++)
        cin>>a[i];
    a[k]=n+1;
    sort(a,a+k+1);
    vector< pair<int,int> > p;
    int last=0;
    for(int i=0;i<=k;i++)
    {
        int l=last+1,r=a[i]-1;
        last=a[i];
        if(l>r)
            continue;
        p.push_back(make_pair(l,r));
    }
    vector< pair<int,int> > all;
    for(int i=0;i<p.size();i++)
        for(int j=i;j<p.size();j++)
            all.push_back(make_pair(p[i].first+p[j].first,p[i].second+p[j].second));
    sort(all.begin(),all.end());
    vector< pair<int,int> > res;
    for(int i=0;i<all.size();i++)
        if(res.empty()||res.back().second+1<all[i].first)
            res.push_back(all[i]);
        else
            res.back().second=all[i].second;
    int ans=0;
    for(int i=0;i<res.size();i++)
        ans+=res[i].second-res[i].first+1;
    cout<<ans;
}
